{% extends '::base.html.twig' %}

{% block title %}Usuarios{% endblock title %}
{% form_theme formDireccion '::Forms/bootstrapForm.html.twig' %}

{% block stylesheets %}
  <link rel="stylesheet" type="text/css" href="{{ asset('vendor/css/jquery.dataTables.css') }}">
{% endblock %}

{% block body -%}
<div class="container generalContainer" id="pf_opmenu">
    <h1>Usuarios</h1>
  {{ form_start(form) }}
  
    <table class="table table-bordered table-striped table-condensed">
        <tbody>
            <tr> 
        <td>
           <div class="form-group">
          {{ form_row(attribute(form, "activo")) }}
                   </div>
        </td>
            </tr>
       </table>
      
              {{ form_rest(form) }}
              {{ form_end(form) }}
        
<br><br>
     <a type="button" class="btn btn-primary" href="{{ path('usuario_new') }}">
         Crear Usuario
     </a>
    <br><br>
    <table id="usuarios" class="table table-bordered table-striped table-condensed">
        <thead class="head_table">
            <tr>
                <th>Usuario</th>
                <th>Nombre</th>
                <th>A. Paterno</th>
                <th>A. Materno</th>
                <th>Perfil</th>
                <th>Activo</th>
                <th>Acciones</th>
            </tr>
        </thead>
        <tbody>
        {% for entity in entities %}
            <tr>
                <td>{{ entity.uClave }}</td>
                <td>{{ entity.uNombre }}</td>
                <td>{{ entity.uApPaterno }}</td>
                <td>{{ entity.uApMaterno }}</td>
                <td>{{ entity.tipoUsuario.valor }}</td>
                <td align="center"><input {{ entity.activo == 1 ? 'checked' }} type="checkbox" style="width: 30px;height:30px;" name="estado{{ entity.uNumero }}" onchange="actualiza({{ entity.uNumero }}, this);"/> </td>
                <td>
                        <a type="button" class="btn btn-primary"  href="{{ path('usuario_show', { 'id': entity.uNumero }) }}">Ver</a>

                        <a type="button" class="btn btn-primary"  href="{{ path('usuario_edit', { 'id': entity.uNumero }) }}">Editar</a>

                {% if entity.direcciones|length > 0 %}
                    
                        <button type="button" class="btn btn-success" onclick="getDirecciones({{ entity.uNumero }},'{{ entity.uNombre }} {{ entity.uApPaterno }} {{ entity.uApMaterno }}')">Ver {{ entity.direcciones|length }} Direcciones</button>
                {% else %}
                    
                        <button type="button" class="btn btn-warning" onclick="getDirecciones({{ entity.uNumero }},'{{ entity.uNombre }} {{ entity.uApPaterno }} {{ entity.uApMaterno }}')">Ver {{ entity.direcciones|length }} Direcciones</button>
                {% endif %}        

                </td>
            </tr>
        {% endfor %}
        </tbody>
    </table>

<!-- POPUP DTL DIRECCIONES -->
    <div class="modal fade bs-example-modal-lg" id="popup_dir" tabindex="-1" role="dialog" aria-labelledby="myLargeModalLabel" aria-hidden="true">
      <div class="modal-dialog modal-lg">
        <div class="modal-content" id="modal_dir_user">
         
        </div>
      </div>
    </div>

<!-- POPUP NEW DIRECCIONES -->
    <div class="modal fade bs-example-modal-lg" id="popup_new_dir" tabindex="-1" role="dialog" aria-labelledby="myLargeModalLabel" aria-hidden="true">
      <div class="modal-dialog modal-lg">
        <div class="modal-content" id="modal_new_dir">
          <div class="modal-header" id="head_new_dir">           
          </div>
          <div class="modal-body">
                  {{ form_start(formDireccion) }}
                  {% for row in [
                    [ ['pais', 2],              ['cp']    ],
                    [ ['estado'],     ['municipio'],    ['colonia'] ],
                    [ ['calle'],    ['entreCalles', 2]        ],
                    [ ['noExt'],    ['noInt']           ],
                    [ ['referencia', 3]                 ],
                    [ ['telCasa'],   ['telCel']  ]
                    ] 
                  %}
                    <div class="row">   
                    {% for field in row %}
                      <div class="col-xs-{{ field[1] is defined ? field[1] * 4 :  4 }}">
                        {% if (attribute(formDireccion, field[0]) is defined) %}
                          {{ form_row(attribute(formDireccion, field[0])) }}
                        {% endif %}
                      </div>
                    {% endfor %}
                    </div>
                  {% endfor %}
                  {{ form_rest(formDireccion) }}
                  {{ form_end(formDireccion) }}
          </div>
          <div class="modal-footer" id="footer_new_dir">
          </div>
        </div>
      </div>
    </div>

  </div>
    {% endblock %}
  
    {% block javascripts %}
    <script>var testJSON = {{ entities|json_encode()|raw }};</script>
  <script type="text/template" id='DireccionesTemplate'>
      <div class="modal-header">
        <button type="button" class="close" data-dismiss="modal" aria-label="Close"><span aria-hidden="true">&times;</span></button>
        <h4 class="modal-title" id="exampleModalLabel">Direcciones del usuario: <%= usuario %></h4>
      </div>
      <div class="modal-body">
                <div class="table-responsive">
                  <table class="table table-bordered table-hover" id="dtl_dir">
                      <thead>
                        <tr class="info">
                          <th>Direccion(es)</th>
                          <th>Tel. Casa</th>
                          <th>Tel. Celular</th>                          
                          <th>Operaciones</th>
                        </tr>                        
                      </thead>
                      <tbody> 
                        <% 
                        
                            if(Dir.length > 0)
                            {
                            _.each(Dir, function(item, key){ 
                              ADirecciones.push(item)                   
                        %>
                                <tr id="<%= item.idDireccion %>">
                                  <td><%= item.fulldireccion %></td>
                                  <td><%= item.telcasa %></td>
                                  <td><%= item.telCel %></td>
                                  <td>
                                    <button type="button" class="btn btn-info" onclick="editDireccion(<%= idUser %>,'<%= usuario %>',<%= item.idDireccion %>)"><span class="glyphicon glyphicon-pencil"></span></button>
                                    <button type="button" class="btn btn-danger" onclick="deletDir(<%= item.idDireccion %>,<%= idUser %>)"><span class="glyphicon glyphicon-remove"></span></button>
                                  </td>
                                </tr>
                          <%});
                            }else{
                              $("#dtl_dir tbody").html("<tr><td colspan='4'>Aún no hay direcciones registradas</td></tr>");
                            }  
                            %>
                            
                      </tbody>    
                  </table>
                </div>              
      </div>  
      <div class="modal-footer">
        <button type="button" class="btn btn-success" onclick="newDireccion(<%= idUser %>,'<%= usuario %>')">Nueva Dirección</button>
        <button type="button" class="btn btn-default" data-dismiss="modal">Cerrar</button>
      </div>
  </script>
    
<script type="text/javascript">
var urlActualiza = "{{path('_ActualizarUsuarios')}}"; 
var AEdos = new Array();
var ADirecciones = new Array(); 
function actualiza(uNumero, self){

$.post(urlActualiza, {uNumero:uNumero,valor:self.checked}, function(data, textStatus, xhr) {
   /*cosas opcionales que hacer después del éxito */
   if (data.estado!=1){
      alert(data.mensaje);
   }  
  });
  }

  $(document).ready(function() {

    $('#usuarios').dataTable({
    "language":DataTables.languaje.es                    
              });


      $( "select" ).addClass( "form-control" );
      $( "input[type='text']" ).addClass( "form-control" );
      $( "input[type='search']").addClass( "form-control" );
      $( "#usuarios_length" ).addClass( "form-inline" );
      $( "#usuarios_filter" ).addClass( "form-inline" );


    $.getJSON("{{path('estados_json')}}",function(result){
        AEdos = result;
    });

  });
  

  function getDirecciones(idUser,user){
    ADirecciones.length = 0;
  $('#popup_new_dir').modal('hide');
  showLoading("Cargando Direcciones...");
  var urlDirecciones = "{{path('dir_user_json')}}"; 
  $.post(urlDirecciones, {idUser:idUser}, function(data, textStatus, xhr) {

    if(data.estatus == 1 || data.estatus == 0){

      data.usuario =  user;
      data.idUser = idUser;
      hideLoading();
      var template = _.template(document.getElementById("DireccionesTemplate").textContent);
      var html_flujo = template(data);
      hideLoading();
      $("#modal_dir_user").html(html_flujo);
      $('#popup_dir').modal({
        backdrop: 'static',
        keyboard: false
      });

    }else{
      alert("Error en carga de direcciónes");
      hideLoading();
    }
   
  });

  }

  function newDireccion(idUser,usuario){

    $('#mdr_puntoventabundle_direccionesusuarios_cp').val("");
    $('#mdr_puntoventabundle_direccionesusuarios_estado').find('option').remove();
    $('#mdr_puntoventabundle_direccionesusuarios_municipio').find('option').remove();
    $('#mdr_puntoventabundle_direccionesusuarios_colonia').find('option').remove();
    $('#mdr_puntoventabundle_direccionesusuarios_calle').val("");
    $('#mdr_puntoventabundle_direccionesusuarios_entreCalles').val("");
    $('#mdr_puntoventabundle_direccionesusuarios_noExt').val("");
    $('#mdr_puntoventabundle_direccionesusuarios_noInt').val("");
    $('#mdr_puntoventabundle_direccionesusuarios_referencia').val("");
    $('#mdr_puntoventabundle_direccionesusuarios_telCasa').val("");
    $('#mdr_puntoventabundle_direccionesusuarios_telCel').val("");
    
    $('#mdr_puntoventabundle_direccionesusuarios_estado').append('<option value="0">------------------------------------------</option>');

    for(var x=0;x<=AEdos.length-1;x++){
      $('#mdr_puntoventabundle_direccionesusuarios_estado').append('<option value="'+AEdos[x].idEstado+'">'+AEdos[x].nombre+'</option>');
    }  




    usuario = "'"+usuario+"'";
    $('#popup_dir').modal('hide');
    $('#head_new_dir').html('<h4 class="modal-title" id="exampleModalLabel">Nueva Dirección del usuario: <b>'+usuario+'</b></h4>');
    $('#footer_new_dir').html('<button type="button" class="btn btn-primary" onclick="getDirecciones('+idUser+','+usuario+')">Regresar</button>'+
        '<button type="button" class="btn btn-success" onclick=makeDireccion('+idUser+',"N")>Guardar</button>');
    $('#popup_new_dir').modal({
      backdrop: 'static',
      keyboard: false
    });
  }


  function editDireccion(idUser,usuario,idDireccion){

    $('#mdr_puntoventabundle_direccionesusuarios_cp').val("");
    $('#mdr_puntoventabundle_direccionesusuarios_estado').find('option').remove();
    $('#mdr_puntoventabundle_direccionesusuarios_municipio').find('option').remove();
    $('#mdr_puntoventabundle_direccionesusuarios_colonia').find('option').remove();
    $('#mdr_puntoventabundle_direccionesusuarios_calle').val("");
    $('#mdr_puntoventabundle_direccionesusuarios_entreCalles').val("");
    $('#mdr_puntoventabundle_direccionesusuarios_noExt').val("");
    $('#mdr_puntoventabundle_direccionesusuarios_noInt').val("");
    $('#mdr_puntoventabundle_direccionesusuarios_referencia').val("");
    $('#mdr_puntoventabundle_direccionesusuarios_telCasa').val("");
    $('#mdr_puntoventabundle_direccionesusuarios_telCel').val("");
    
    showLoading('Cargando datos');
    var getMunicipios = "{{path('user_mun_json')}}"; 
    var getColonias = "{{path('user_col_json')}}"; 


    $('#mdr_puntoventabundle_direccionesusuarios_estado').append('<option value="0">------------------------------------------</option>');

    for(var x=0;x<=AEdos.length-1;x++){
      $('#mdr_puntoventabundle_direccionesusuarios_estado').append('<option value="'+AEdos[x].idEstado+'">'+AEdos[x].nombre+'</option>');
    }  

    for(var d=0;d<=ADirecciones.length-1;d++){
      if(ADirecciones[d].idDireccion == idDireccion){
        $('#mdr_puntoventabundle_direccionesusuarios_cp').val(ADirecciones[d].cp);
        var CP = ADirecciones[d].cp;
        var Col = ADirecciones[d].colonia;
        var getInformacion = "{{path('get_info_dir_json')}}"; 
        $.post(getInformacion, {ident:1,CP:CP}, function(data, textStatus, xhr) {

              if(data.estatus == 1){

                hideLoading();
                $('#mdr_puntoventabundle_direccionesusuarios_estado').val(data.estados.idEstado);
                $('#mdr_puntoventabundle_direccionesusuarios_colonia').append('<option value="0">------------------------------------------</option>');
                for(var c=0;c<=data.colonias.length-1;c++){
                    $('#mdr_puntoventabundle_direccionesusuarios_colonia').append('<option value="'+data.colonias[c].cp+"|"+data.colonias[c].nombre+'">'+data.colonias[c].nombre+'</option>');
                }
                for(var m=0;m<=data.municipios.length-1;m++){
                    $('#mdr_puntoventabundle_direccionesusuarios_municipio').append('<option value="'+data.municipios[m].idMunicipio+'">'+data.municipios[m].nombre+'</option>');
                }  

                $('#mdr_puntoventabundle_direccionesusuarios_municipio option[value='+data.colonias[0].municipio.idMunicipio+']').attr('selected','selected');
                $('#mdr_puntoventabundle_direccionesusuarios_colonia').val(CP+"|"+Col);

              }else{
                alert("Error al cargar datos");
                $('#mdr_puntoventabundle_direccionesusuarios_estado').find('option').remove(); 
                $('#mdr_puntoventabundle_direccionesusuarios_municipio').find('option').remove();
                $('#mdr_puntoventabundle_direccionesusuarios_colonia').find('option').remove();
                hideLoading();
              }
           
          });

        
        $('#mdr_puntoventabundle_direccionesusuarios_calle').val(ADirecciones[d].calle);
        $('#mdr_puntoventabundle_direccionesusuarios_entreCalles').val(ADirecciones[d].entreCalles);
        $('#mdr_puntoventabundle_direccionesusuarios_noExt').val(ADirecciones[d].noExt);
        $('#mdr_puntoventabundle_direccionesusuarios_noInt').val(ADirecciones[d].noInt);
        $('#mdr_puntoventabundle_direccionesusuarios_referencia').val(ADirecciones[d].referencia);
        $('#mdr_puntoventabundle_direccionesusuarios_telCasa').val(ADirecciones[d].telcasa);
        $('#mdr_puntoventabundle_direccionesusuarios_telCel').val(ADirecciones[d].telCel);
      }
    }


    usuario = "'"+usuario+"'";
    $('#popup_dir').modal('hide');
    $('#head_new_dir').html('<h4 class="modal-title" id="exampleModalLabel">Editar Dirección del usuario: <b>'+usuario+'</b></h4>');
    $('#footer_new_dir').html('<button type="button" class="btn btn-primary" onclick="getDirecciones('+idUser+','+usuario+')">Regresar</button>'+
        '<button type="button" class="btn btn-success" onclick=makeDireccion('+idUser+',"A",'+idDireccion+')>Actualizar</button>');

    hideLoading();
    $('#popup_new_dir').modal({
      backdrop: 'static',
      keyboard: false
    });
  }

  function deletDir(dir,user){
    showLoading('Eliminando Dirección...');
    var urlDeleteDir = "{{path('delete_dir_user_json')}}"; 
    $.post(urlDeleteDir, {user:user,dir:dir}, function(data, textStatus, xhr) {

      if(data.estatus == 1){

        hideLoading();
        $('#dtl_dir #'+dir).remove();
        alert("Se ha Eliminado la direccion con exito");

      }else{
        alert("Ha sido imposible eliminar la dirección");
        hideLoading();
      }
     
    });
  }

  function getInfo(ident){

    var getInformacion = "{{path('get_info_dir_json')}}"; 

    if(ident == 1){
      
      var CP = $('#mdr_puntoventabundle_direccionesusuarios_cp').val();
      $('#mdr_puntoventabundle_direccionesusuarios_colonia').find('option').remove();
      if(CP){      
          showLoading('Validando Codigo Postal...');
          $.post(getInformacion, {ident:ident,CP:CP}, function(data, textStatus, xhr) {

              if(data.estatus == 1){

                hideLoading();
                $('#mdr_puntoventabundle_direccionesusuarios_estado').val(data.estados.idEstado);
                $('#mdr_puntoventabundle_direccionesusuarios_colonia').append('<option value="0">------------------------------------------</option>');
                for(var c=0;c<=data.colonias.length-1;c++){
                     $('#mdr_puntoventabundle_direccionesusuarios_colonia').append('<option value="'+data.colonias[c].cp+'|'+data.colonias[c].nombre+'">'+data.colonias[c].nombre+'</option>');
                }
                for(var m=0;m<=data.municipios.length-1;m++){
                    $('#mdr_puntoventabundle_direccionesusuarios_municipio').append('<option value="'+data.municipios[m].idMunicipio+'">'+data.municipios[m].nombre+'</option>');
                }  

                $('#mdr_puntoventabundle_direccionesusuarios_municipio option[value='+data.colonias[0].municipio.idMunicipio+']').attr('selected','selected');


              }else{
                alert("El codigo postal no existe");
                $('#mdr_puntoventabundle_direccionesusuarios_estado').val(0); 
                $('#mdr_puntoventabundle_direccionesusuarios_municipio').find('option').remove();
                $('#mdr_puntoventabundle_direccionesusuarios_colonia').find('option').remove();
                hideLoading();
              }
           
          });
      }else{
        $('#mdr_puntoventabundle_direccionesusuarios_estado').val(0); 
        $('#mdr_puntoventabundle_direccionesusuarios_municipio').find('option').remove();
        $('#mdr_puntoventabundle_direccionesusuarios_colonia').find('option').remove();
      }    
    }else if(ident == 2){

        var EDO = $('#mdr_puntoventabundle_direccionesusuarios_estado').val();
        if(EDO != 0){

          $('#mdr_puntoventabundle_direccionesusuarios_municipio').find('option').remove();
          $('#mdr_puntoventabundle_direccionesusuarios_colonia').find('option').remove();
          $('#mdr_puntoventabundle_direccionesusuarios_cp').val("");      

          showLoading('Cargando Municipios...');
          $.post(getInformacion, {ident:ident,EDO:EDO}, function(data, textStatus, xhr) {

              if(data.estatus == 1){

                hideLoading();
                $('#mdr_puntoventabundle_direccionesusuarios_municipio').append('<option value="0">------------------------------------------</option>');
                for(var m=0;m<=data.municipios.length-1;m++){
                    $('#mdr_puntoventabundle_direccionesusuarios_municipio').append('<option value="'+data.municipios[m].idMunicipio+'">'+data.municipios[m].nombre+'</option>');
                }

              }else{
                alert("ERROR AL CARGAR MUNICIPIOS");
                hideLoading();
              }
           
          });        
        }

    }else if(ident == 3){

      var MUN = $('#mdr_puntoventabundle_direccionesusuarios_municipio').val();
      if(MUN != 0){
        $('#mdr_puntoventabundle_direccionesusuarios_colonia').find('option').remove();
        $('#mdr_puntoventabundle_direccionesusuarios_cp').val("");      

          showLoading('Cargando Colonias...');
          $.post(getInformacion, {ident:ident,MUN:MUN}, function(data, textStatus, xhr) {

              if(data.estatus == 1){

                hideLoading();
                $('#mdr_puntoventabundle_direccionesusuarios_colonia').append('<option value="0">------------------------------------------</option>');
                for(var c=0;c<=data.colonias.length-1;c++){
                    $('#mdr_puntoventabundle_direccionesusuarios_colonia').append('<option value="'+data.colonias[c].cp+'|'+data.colonias[c].nombre+'">'+data.colonias[c].nombre+'</option>');
                }

              }else{
                alert("ERROR AL CARGAR COLONIAS");
                hideLoading();
              }
           
          });     

      }

    }else if(ident == 4){

        var CP = $('#mdr_puntoventabundle_direccionesusuarios_colonia').val();
        if(CP != 0){
          var posicion = CP.indexOf('|');
          CP = CP.substring(0,posicion);
          $('#mdr_puntoventabundle_direccionesusuarios_cp').val(CP);
        }     

    }
  }

  function makeDireccion(user,ident,idDir){

    var pais          = $('#mdr_puntoventabundle_direccionesusuarios_pais').val();
    var cp            = $('#mdr_puntoventabundle_direccionesusuarios_cp').val();
    var edo           = $('#mdr_puntoventabundle_direccionesusuarios_estado').val();
    var mun           = $('#mdr_puntoventabundle_direccionesusuarios_municipio').val();
    var col           = $('#mdr_puntoventabundle_direccionesusuarios_colonia').val();
    var calle         = $('#mdr_puntoventabundle_direccionesusuarios_calle').val();
    var entreCalles   = $('#mdr_puntoventabundle_direccionesusuarios_entreCalles').val();
    var noExt         = $('#mdr_puntoventabundle_direccionesusuarios_noExt').val();
    var noInt         = $('#mdr_puntoventabundle_direccionesusuarios_noInt').val();
    var referencia    = $('#mdr_puntoventabundle_direccionesusuarios_referencia').val();
    var telcasa       = $('#mdr_puntoventabundle_direccionesusuarios_telCasa').val();
    var telCel        = $('#mdr_puntoventabundle_direccionesusuarios_telCel').val();
    var makeDireccion = "{{path('make_dir_json')}}";

    if(pais && cp && edo != "0" && mun != "0" && col != "0" && calle && entreCalles && telcasa){

          if(telcasa.length > 9){
              if(telCel){

                  if(telCel.length > 9){

                    if(ident == "N"){                
                      showLoading('Guardando Dirección...');
                    }else if(ident == "A"){
                      showLoading('Actualizando Dirección...');
                    }
                    var posicion = col.indexOf('|');
                    col = col.substring(posicion+1);
                    $.post(makeDireccion, {
                          ident:ident,
                          pais:pais,
                          cp:cp,
                          edo:edo,
                          mun:mun,
                          col:col,
                          calle:calle,
                          entreCalles:entreCalles,
                          noExt:noExt,
                          noInt:noInt,
                          referencia:referencia,
                          telcasa:telcasa,
                          telCel:telCel,
                          user:user,
                          idDir:idDir
                        }, function(data, textStatus, xhr) {

                        if(data.estatus == 1){

                          alert(data.mensaje);
                          hideLoading();

                        }else{
                          alert("ERROR AL GUARDAR DATOS");
                          hideLoading();
                        }
                     
                    });


                  }else{
                    alert('El número de celular debe ser a 10 digitos (Lada + número)');
                  }

              }else{

                if(ident == "N"){
                      showLoading('Guardando Dirección...');
                    }else if(ident == "A"){
                      showLoading('Actualizando Dirección...');
                    }
                    var posicion = col.indexOf('|');
                    col = col.substring(posicion+1);

                    $.post(makeDireccion, {
                          ident:ident,
                          pais:pais,
                          cp:cp,
                          edo:edo,
                          mun:mun,
                          col:col,
                          calle:calle,
                          entreCalles:entreCalles,
                          noExt:noExt,
                          noInt:noInt,
                          referencia:referencia,
                          telcasa:telcasa,
                          telCel:telCel,
                          user:user,
                          idDir:idDir
                        }, function(data, textStatus, xhr) {

                        if(data.estatus == 1){

                          alert(data.mensaje);
                          hideLoading();

                        }else{
                          alert("ERROR AL GUARDAR DATOS");
                          hideLoading();
                        }
                     
                    });

              }
          }else{
            alert('El número de casa debe ser a 10 digitos (Lada + número)');
          }
    }else{
      alert("Los siguientes campos son obligatorios:</br>->País</br>->CP (Codigo Postal)</br>->Estado</br>->Municipio</br>->Colonia</br>->Calle</br>->Entre Calles</br>->Tel Casa");
    }
  }
</script>
{% endblock %}
